package io.chamaeleon.barterph.api.web.rest.errors;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.annotation.JsonIgnore;
import lombok.*;
import org.springframework.http.HttpStatus;

@Getter
@AllArgsConstructor(access = AccessLevel.PRIVATE)
@JsonFormat(shape = JsonFormat.Shape.OBJECT)
public enum ApiErrorCode {
  BAD_REQUEST(400_000, HttpStatus.BAD_REQUEST),
  MISSING_PARAMETER(400_001, HttpStatus.BAD_REQUEST),
  VALIDATION_ERROR(400_002, HttpStatus.BAD_REQUEST),
  INVALID_OR_MISSING_REQUEST(400_003, HttpStatus.BAD_REQUEST),
  INVALID_FOR_FB_AND_GOOGLE(400_004, HttpStatus.BAD_REQUEST),
  INVALID_PHOTO(400_005, HttpStatus.BAD_REQUEST),
  EMPTY_FILE(400_006, HttpStatus.BAD_REQUEST),
  MISSING_DEVICE_ID_HEADER(400_007, HttpStatus.BAD_REQUEST),

  //-- 401
  UNAUTHORIZED(401_000, HttpStatus.UNAUTHORIZED),

  //-- 403 forbidden
  ACCESS_DENIED(403_000, HttpStatus.FORBIDDEN),
  SESSION_EXPIRED(403_001, HttpStatus.FORBIDDEN),
  AUTH_ACCOUNT_SUSPENDED(403_002, HttpStatus.FORBIDDEN),
  AUTH_ACCOUNT_NOT_FOUND(403_003, HttpStatus.FORBIDDEN),
  AUTH_FB_PROFILE_NOT_FOUND(403_004, HttpStatus.FORBIDDEN),
  AUTH_GOOGLE_PROFILE_NOT_FOUND(403_005, HttpStatus.FORBIDDEN),
  INCORRECT_PASSWORD(403_006, HttpStatus.FORBIDDEN),

  //-- not found : 404
  RESOURCE_NOT_FOUND(404_000, HttpStatus.NOT_FOUND),
  ACCOUNT_NOT_FOUND(404_001, HttpStatus.NOT_FOUND),
  FILE_NOT_FOUND(404_002, HttpStatus.NOT_FOUND),
  BARTER_NOT_FOUND(404_003, HttpStatus.NOT_FOUND),
  TRADE_PARTNER_NOT_FOUND(404_004, HttpStatus.NOT_FOUND),
  OFFER_NOT_FOUND(404_005, HttpStatus.NOT_FOUND),
  COMMENT_NOT_FOUND(404_006, HttpStatus.NOT_FOUND),

  //-- method not allowed: 405
  METHOD_NOT_ALLOWED(405_000, HttpStatus.METHOD_NOT_ALLOWED),

  //-- conflict: 409
  CONFLICT(409_000, HttpStatus.CONFLICT),
  DUPLICATE_MOBILE_NUMBER(409_001, HttpStatus.CONFLICT),
  DUPLICATE_FB_ID(409_002, HttpStatus.CONFLICT),
  ACCOUNT_NOT_ACTIVATED(409_003, HttpStatus.CONFLICT),
  DUPLICATE_EMAIL(409_004, HttpStatus.CONFLICT),
  DUPLICATE_GOOGLE_ID(409_005, HttpStatus.CONFLICT),
  NOTIFICATION_SAME_SENDER_RECEIVER(409_006, HttpStatus.CONFLICT),
  USER_CANNOT_REPLY_TO_OFFER(409_007, HttpStatus.CONFLICT),

  //-- Unsupported media type: 415
  UNSUPPORTED_MEDIA_TYPE(415_000, HttpStatus.UNSUPPORTED_MEDIA_TYPE),

  //-- Internal server error
  INTERNAL_ERROR(500_000, HttpStatus.INTERNAL_SERVER_ERROR),
  FILE_UPLOAD_ERROR(500_001, HttpStatus.INTERNAL_SERVER_ERROR),
  OPERATION_FAILED(500_002, HttpStatus.INTERNAL_SERVER_ERROR);

  private int code = 0;

  @JsonIgnore
  private HttpStatus httpStatus;

}
